diff --git a/aggregation.c b/aggregation.c
index 47802ed..245b0d3 100644
--- a/aggregation.c
+++ b/aggregation.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/bat-hosts.c b/bat-hosts.c
index 7a3d712..57e7d69 100644
--- a/bat-hosts.c
+++ b/bat-hosts.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/bat-hosts.h b/bat-hosts.h
index 3cfec66..660b184 100644
--- a/bat-hosts.h
+++ b/bat-hosts.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/batadv_packet_compat.h b/batadv_packet_compat.h
index ee99fb0..58b9c01 100644
--- a/batadv_packet_compat.h
+++ b/batadv_packet_compat.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/bisect_iv.c b/bisect_iv.c
index d2dd8cf..1cb11b8 100644
--- a/bisect_iv.c
+++ b/bisect_iv.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/bisect_iv.h b/bisect_iv.h
index 40424ea..ea39177 100644
--- a/bisect_iv.h
+++ b/bisect_iv.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/bonding.c b/bonding.c
index 5407d28..947f22b 100644
--- a/bonding.c
+++ b/bonding.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/dat_cache.c b/dat_cache.c
index b666a43..4c72360 100644
--- a/dat_cache.c
+++ b/dat_cache.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/debug.c b/debug.c
index 5629e1f..b715885 100644
--- a/debug.c
+++ b/debug.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/debug.h b/debug.h
index ac208fe..1e97a5a 100644
--- a/debug.h
+++ b/debug.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/elp_interval.c b/elp_interval.c
index a951528..b294eaf 100644
--- a/elp_interval.c
+++ b/elp_interval.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/fragmentation.c b/fragmentation.c
index 974345a..2f3d3b9 100644
--- a/fragmentation.c
+++ b/fragmentation.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/functions.c b/functions.c
index bf6057c..f7a3080 100644
--- a/functions.c
+++ b/functions.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/functions.h b/functions.h
index b85bbf1..33b57da 100644
--- a/functions.h
+++ b/functions.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/genl.h b/genl.h
index cab6ad3..7177ce9 100644
--- a/genl.h
+++ b/genl.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/gw_mode.c b/gw_mode.c
index 1b102a3..996ca08 100644
--- a/gw_mode.c
+++ b/gw_mode.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/hop_penalty.c b/hop_penalty.c
index e43595b..11f30ae 100644
--- a/hop_penalty.c
+++ b/hop_penalty.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/icmp_helper.c b/icmp_helper.c
index a523f23..459ea63 100644
--- a/icmp_helper.c
+++ b/icmp_helper.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>, Simon Wunderlich
+ * Marek Lindner <marek.lindner@mailbox.org>, Simon Wunderlich
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/icmp_helper.h b/icmp_helper.h
index d117993..f8dbaa9 100644
--- a/icmp_helper.h
+++ b/icmp_helper.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/interface.c b/interface.c
index 6f70468..dfe5ad4 100644
--- a/interface.c
+++ b/interface.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/loglevel.c b/loglevel.c
index ab6f033..a26559a 100644
--- a/loglevel.c
+++ b/loglevel.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/main.c b/main.c
index 45038d3..9516dee 100644
--- a/main.c
+++ b/main.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/main.h b/main.h
index 555af07..646ef5d 100644
--- a/main.h
+++ b/main.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/man/batctl.8 b/man/batctl.8
index b5be0b8..f7522b4 100644
--- a/man/batctl.8
+++ b/man/batctl.8
@@ -515,7 +515,7 @@ addresses.
 .BR traceroute (1),
 .BR trace-cmd (1)
 .SH AUTHOR
-batctl was written by Andreas Langer <an.langer@gmx.de> and Marek Lindner <mareklindner@neomailbox.ch>.
+batctl was written by Andreas Langer <an.langer@gmx.de> and Marek Lindner <marek.lindner@mailbox.org>.
 .PP
-This manual page was written by Simon Wunderlich <sw@simonwunderlich.de>, Marek Lindner <mareklindner@neomailbox.ch> and
+This manual page was written by Simon Wunderlich <sw@simonwunderlich.de>, Marek Lindner <marek.lindner@mailbox.org> and
 Andrew Lunn <andrew@lunn.ch>
diff --git a/mcast_flags.c b/mcast_flags.c
index 9535981..9dcb90c 100644
--- a/mcast_flags.c
+++ b/mcast_flags.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/netlink.c b/netlink.c
index a41548d..31aec5e 100644
--- a/netlink.c
+++ b/netlink.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>, Andrew Lunn <andrew@lunn.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>, Andrew Lunn <andrew@lunn.ch>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/netlink.h b/netlink.h
index 237f760..03da947 100644
--- a/netlink.h
+++ b/netlink.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>, Andrew Lunn <andrew@lunn.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>, Andrew Lunn <andrew@lunn.ch>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/orig_interval.c b/orig_interval.c
index 0201b15..4e13016 100644
--- a/orig_interval.c
+++ b/orig_interval.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/ping.c b/ping.c
index f2f6c41..14d9c21 100644
--- a/ping.c
+++ b/ping.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/routing_algo.c b/routing_algo.c
index 8d1b63e..5aa4597 100644
--- a/routing_algo.c
+++ b/routing_algo.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/statistics.c b/statistics.c
index 134a8cd..9506308 100644
--- a/statistics.c
+++ b/statistics.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/sys.c b/sys.c
index dcef51f..0b38677 100644
--- a/sys.c
+++ b/sys.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/sys.h b/sys.h
index 1f27347..493f41f 100644
--- a/sys.h
+++ b/sys.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/tcpdump.h b/tcpdump.h
index be64aeb..91f9242 100644
--- a/tcpdump.h
+++ b/tcpdump.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/throughput_override.c b/throughput_override.c
index 9767d9e..6c316ff 100644
--- a/throughput_override.c
+++ b/throughput_override.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Marek Lindner <mareklindner@neomailbox.ch>
+ * Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/traceroute.c b/traceroute.c
index 2409c30..a0fb925 100644
--- a/traceroute.c
+++ b/traceroute.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */
diff --git a/translate.c b/translate.c
index 0101724..73510ea 100644
--- a/translate.c
+++ b/translate.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0
 /* Copyright (C) B.A.T.M.A.N. contributors:
  *
- * Andreas Langer <an.langer@gmx.de>, Marek Lindner <mareklindner@neomailbox.ch>
+ * Andreas Langer <an.langer@gmx.de>, Marek Lindner <marek.lindner@mailbox.org>
  *
  * License-Filename: LICENSES/preferred/GPL-2.0
  */